﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace sfListView.Controls
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class SearchBarFilter : ContentView
    {
        public static readonly BindableProperty DataSourceProperty = BindableProperty.Create(
            propertyName: "DataSource",
            defaultValue: typeof(object),
            returnType: typeof(object),
            declaringType: typeof(SearchBarFilter),
            defaultBindingMode: BindingMode.TwoWay,
            propertyChanged: DataSourcePropertyChanged);

        public string DataSource
        {
            get { return base.GetValue(DataSourceProperty).ToString(); }
            set { base.SetValue(DataSourceProperty, value); }
        }

        private static void DataSourcePropertyChanged(BindableObject bindable, object oldValue, object newValue)
        {
            var thisControl = (SearchBarFilter)bindable;
            thisControl.autoComplete.DataSource = (IEnumerable<object>)newValue;
        }


        public SearchBarFilter()
        {
            InitializeComponent();

            TapGestureRecognizer btnftr = new TapGestureRecognizer();
            btnftr.Command = new Command(OnClickedFilter);
            filterButton.GestureRecognizers.Add(btnftr);

            //TapGestureRecognizer autocom = new TapGestureRecognizer();
            //autocom.Command = new Command(OnClickedAutoComp);
            //autoComplete.GestureRecognizers.Add(autocom);

        }


        public event EventHandler ClickedFilter;
        public void OnClickedFilter(object sender)
        {
            if (ClickedFilter != null)
            {
                this.ClickedFilter(this, EventArgs.Empty);
            }
        }

        private void FilterButton_Clicked(object sender, EventArgs e)
        {
            this.ClickedFilter(this, EventArgs.Empty);
        }

        public event EventHandler ClickedAutoComplete;
        public void OnClickedAutoComplete(object sender)
        {
            if (ClickedAutoComplete != null)
            {
                this.ClickedAutoComplete(this, EventArgs.Empty);
            }
        }

        private void AutoComplete_SelectionChanged(object sender, Syncfusion.SfAutoComplete.XForms.SelectionChangedEventArgs e)
        {
            var searchbox = (Syncfusion.SfAutoComplete.XForms.SfAutoComplete)sender;
            this.ClickedAutoComplete(searchbox.SelectedItem, EventArgs.Empty);
        }

    }

}