﻿using sfListView.Models;
using sfListView.ViewModels;
using Syncfusion.ListView.XForms;
using Syncfusion.ListView.XForms.Control.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace sfListView.Views.Events
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class EventsPage : ContentPage
    {
        private EventsViewModel vm;
        private List<DateTime> selectedDateFilter;

        public EventsPage()
        {
            InitializeComponent();

            vm = new EventsViewModel();
            BindingContext = vm;

        }

        private async void NavbarTop_ClickedBack(object sender, EventArgs e)
        {
            await Navigation.PopModalAsync();
        }


        private async void PullToRefresh_Refreshing(object sender, EventArgs e)
        {
            //pullToRefresh.IsRefreshing = true;
            await vm.OnRefreshListView();
            //pullToRefresh.IsRefreshing = false; 
        }


        private async void CategorycomboBox_SelectionChanged(object sender, Syncfusion.XForms.ComboBox.SelectionChangedEventArgs e)
        {
            //pullToRefresh.IsRefreshing = true;
            if (e.Value != null)
                vm.Filter.Execute(e.Value);
            //pullToRefresh.IsRefreshing = false;
            //await Task.Delay(2000);
            //mainListView.RefreshView();
        }

        private void MainListView_ItemSelected(object sender, SelectedItemChangedEventArgs e)
        {
            try
            {
                var myevent = (EventForListDto)e.SelectedItem;
                if (myevent != null) { }
                //await Helpers.CustomNavigation(this, new EventDetailsPage(myevent));
                else
                {

                }
               ((ListView)sender).SelectedItem = null;
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }


    }

    public class ExtendedListView : SfListView
    {
        VisualContainer container;
        public ExtendedListView()
        {
            container = this.GetVisualContainer();
            //container.PropertyChanged += Container_PropertyChanged;
        }

        private void Container_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            Device.BeginInvokeOnMainThread(async () =>
            {
                if (e.PropertyName == nameof(Height))
                {
                    var extent = (double)container.GetType().GetRuntimeProperties().FirstOrDefault(container => container.Name == "TotalExtent").GetValue(container);
                    this.HeightRequest = extent;
                }
            });
        }
    }
}